poj 2337 欧拉回路按照最小字典序输出+注意为了按最小字典序怎么处理邻接表

http://poj.org/problem?id=2337

WA了好久,昨晚1点多睡不着写的,狂WA,当时是因为用邻接矩阵存储,比如aba,aa只能存下一个,这个之前还没遇到过,今天才注意到--邻接矩阵无法存储平行边,

关于欧拉回路判断看我另几篇日志或者看我的欧拉总结

再贴个输出欧拉回路的模板

其中,参数u是起点,注意如果是输出欧拉路径的话,u必须是出度比入度大一的那个点,如果输出欧拉回路,随便按要求找个就行

void euler(int u)
{
    for(int i=head[u];i!=-1;i=edge[i].next)
    {
        if(!edge[i].vis)
        {
            //////////////
            //cout << "caodan" << edge[i].to << endl;
            /////////////
            edge[i].vis=1;
            euler(edge[i].to);
            path[ecnt++]=i;
        }
    }
}

这道题最重要的就是怎么输出字典序的最短路了

注意:

1、链式前向星(邻接表)是“后插式的”,比如aa.aba,即使你先加入边aa,后加入aba,但是遍历的时候,head[u]直接连得还是aba,所以对于起点相同的,要按字典序由大到小排序,从而使得链式前向星里的是按照从小到大,对于起点不同的,直接按字典序由小到大即可,具体见我写的cmp函数:

bool cmp(const string a, const string b)
{
    if(a[0]==b[0])return a>b;
    return a<b;
   // if(a<b && a[a.size()-1]>b[b.size()-1])return a>b;

}

2、首先对所有输入的按照1的方法排序,从而保证遍历的时候是按照字典序遍历的,

做这个题真的对dfs,还有图的存储方式重新思考了。。。

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <algorithm>
#include <map>
#include <stack>

using namespace std;

#define rep(i, s, e) for(int (i)=(s);(i)<(e);(i)++)
#define repe(i, s, e) for(int (i)=(s);(i)<=(e);(i)++)
#define arclr(array, a) memset(array, a, sizeof(array))
#define Debug(i) cout<<"##fuck "<<i<<endl

const int SIZE = 1000+100;
const int SLEN=28;
const int tb = 26;
int mat[tb][tb];
int father[tb],ex[tb],id[tb],od[tb],head[SIZE];
int path[SIZE],ecnt;

struct Node
{
    int to,next;
    int vis;
}edge[SIZE];

void addedge(int u, int v, int k)
{
    edge[k].to=v;
    edge[k].next=head[u];
    edge[k].vis=0;
    head[u]=k;
}
inline int idx(char x)
{
    return x-'a';
}
bool cmp(const string a, const string b)
{
    if(a[0]==b[0])return a>b;
    return a<b;
   // if(a<b && a[a.size()-1]>b[b.size()-1])return a>b;

}
void init()
{
    ecnt=0;
    arclr(head, 0xff);
    arclr(path, 0xff);
    arclr(ex,0);
    arclr(id,0);
    arclr(od,0);
    rep(i,0,tb)
        father[i]=i;
}
string str[SIZE];

int Find(int x)
{
    if(x!=father[x])father[x]=Find(father[x]);
    return father[x];
}

void Union(int x, int y)
{
    x=Find(x);
    y=Find(y);
    if(x!=y)father[x]=y;
}

int judge()
{
    int scnt=0;
    rep(i,0,tb)
    {
        if(ex[i] && Find(i)==i)
        {
            scnt++;
            if(scnt>1)return -1;
        }
    }
    int acnt=0,bcnt=0,pos=-1;
    rep(i,0,tb)
        if(ex[i])
        {
            if(id[i]==od[i])continue;
            if(id[i] == od[i]+1){acnt++;continue;}
            if(id[i] == od[i]-1){pos=i;bcnt++;continue;}
            //Debug(2);//////////
            return -1;
        }
    //Debug(3);
    if(!acnt&&!bcnt)return -2;//回路
    if(acnt==1&&bcnt==1)return pos;
    else return -1;
}
void euler(int u)
{
    for(int i=head[u];i!=-1;i=edge[i].next)
    {
        if(!edge[i].vis)
        {
            //////////////
            //cout << "caodan" << edge[i].to << endl;
            /////////////
            edge[i].vis=1;
            euler(edge[i].to);
            path[ecnt++]=i;
        }
    }
}

void output()
{
    for(int i=ecnt-1;i>0;i--)
            cout << str[path[i]] << '.';
    cout << str[path[0]] << endl;
}
int main()
{
   //freopen("poj2337.txt","r",stdin);
    int ncase,n,u,v;
    scanf("%d",&ncase);
    while(ncase--)
    {
        init();
        scanf("%d",&n);
        rep(i,0,n)
            cin>>str[i],edge[i].vis=0;
        sort(str,str+n,cmp);
         //////////////////
        //rep(i,0,n)
         // cout << "##**##" << str[i] << endl;
        //////////////////
        rep(i,0,n)
        {
            u=idx(str[i][0]);
            v=idx(str[i][str[i].size()-1]);
            addedge(u,v,i);
            id[v]++;
            od[u]++;
            ex[u]=ex[v]=1;
            Union(u,v);
        }
       int result=judge();
        if(result == -1)
        {
            printf("***\n");
            continue;
        }
        if(result==-2)
        {
             euler(idx(str[0][0]));
        }
        else
        {
            euler(result);
        }

        output();
    }
    return 0;
}

poj 2337 欧拉回路按照最小字典序输出+注意为了按最小字典序怎么处理邻接表

时间: 2024-10-14 01:09:08

poj 2337 欧拉回路按照最小字典序输出+注意为了按最小字典序怎么处理邻接表的相关文章

poj 2337 之 有向图 欧拉路径输出

/* poj 2337 之 有向图 欧拉路径输出  每个单词看作一条有向边,顶点即为单词首尾字母,然后求欧拉路径即可. 1)为保证字典序,先对单词按字典序排序 2)深搜,输出单词序列 */ 1 #include <iostream> 2 #include <fstream> 3 #include <sstream> 4 #include <cstdlib> 5 #include <cstdio> 6 #include <cstddef>

poj 1815 Friendship 最小割输出最小方案

这题卡了好久啊,最小割模型很容易想,拆点就行.就像poj的Thieves一样 每个点 a拆成 a->a',容量为1. 其他相连的点 a'->b ,容量为INF 源连接s',t连接汇 问题在于输出最小的割集 更好的方法我还不会,只能枚举. 这里基于贪心的思想,从小到大删边, 若删除i->i',会使得最小割变小,则输出i,并且i->i'这条边不要恢复 若最小割不变,则恢复这条边,继续枚举. 一开始就是因为恢复了要割去的边,无限WA. #include<cstdio> #in

POJ 2337 Catenyms (欧拉回路+并查集)

题目地址:POJ 2337 这题跟POJ 1386差不多,只不过这题多一个输出路径而已. 按字母来建边,每个单词的首字母和尾字母加边.先判断是否连通,然后判断每个字母的入度和出度不能出现差的绝对值大于2,然后入度和出度差的绝对值为1的不能超过两个.就可以形成欧拉路径 代码如下: #include <iostream> #include <string.h> #include <math.h> #include <queue> #include <alg

poj 2337 有向图输出欧拉路径

Catenyms Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 10186   Accepted: 2650 Description A catenym is a pair of words separated by a period such that the last letter of the first word is the same as the last letter of the second. For

POJ 2337 欧拉路

Catenyms Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 11214   Accepted: 2908 Description A catenym is a pair of words separated by a period such that the last letter of the first word is the same as the last letter of the second. For

POJ 3522 Slim Span (Kruskal +枚举 边权差最小的生成树)

Slim Span Time Limit: 5000MS Memory Limit: 65536K Total Submissions: 6685 Accepted: 3544 Description Given an undirected weighted graph G, you should find one of spanning trees specified as follows. The graph G is an ordered pair (V, E), where V is a

POJ 3020:Antenna Placement(无向二分图的最小路径覆盖)

Antenna Placement Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 6334   Accepted: 3125 Description The Global Aerial Research Centre has been allotted the task of building the fifth generation of mobile phone nets in Sweden. The most st

[经典面试题]输入一个排好序的数组的一个旋转,输出旋转数组的最小元素。

[题目] 把一个数组最开始的若干个元素搬到数组的末尾,我们称之为数组的旋转.输入一个排好序的数组的一个旋转,输出旋转数组的最小元素.例如数组{3, 4, 5, 1, 2}为{1, 2, 3, 4, 5}的一个旋转,该数组的最小值为1. [分析] 这道题最直观的解法并不难.从头到尾遍历数组一次,就能找出最小的元素,时间复杂度显然是O(N).但这个思路没有利用输入数组的特性,我们应该能找到更好的解法. 我们注意到旋转之后的数组实际上可以划分为两个排序的子数组,而且前面的子数组的元素都大于或者等于后面

hdu 2242 无向图/求用桥一分为二后使俩个bcc点权值和之差最小并输出 /缩点+2次新图dfs

题意如标题所述, 先无向图缩点,统计出每个bcc权,建新图,然后一遍dfs生成树,标记出每个点(新图)以及其子孙的权值之和.这样之后就可以dfs2来枚举边(原图的桥),更新最小即可. 调试了半天!原来是建老图时候链式前向星和新图的vector<vector< int>>俩种存图搞乱了!!!不可原谅!哎!愚蠢!愚不可及!提交后1A. 后来百度之后,发现说是用树形dp,看了代码解法,竟然和我的是一样的算法..原来这种算法可以叫树形dp...的确有点dp味道..不过感觉不太浓.. 以后多